import 'package:msg/msg.dart';

class IncrementMsg extends Msg<int> {
  IncrementMsg(int amount)
      : super(
          update: (current) => current + amount,
          cmd: (current) =>
              Cmd.ofEffect(() => print('Incrementing $current by $amount')),
        );
}

class DecrementMsg extends Msg<int> {
  DecrementMsg(int amount)
      : super(
          update: (current) => current - amount,
          cmd: (current) =>
              Cmd.ofEffect(() => print('Decrementing $current by $amount')),
        );
}

Future<void> main(List<String> arguments) async {
  final store = Store(initialModel: 0);

  Future<void> printValue() async {
    await Future.delayed(Duration.zero);
    print('Current store value: ${store.model}\n');
  }

  await printValue();

  store.send(IncrementMsg(1));
  await printValue();

  store.send(DecrementMsg(2));
  await printValue();

  store.send(IncrementMsg(11));
  await printValue();

  store.send(DecrementMsg(5));
  await printValue();
}
