import 'dart:async';

import 'package:msg/src/private/cmd_concrete.dart';
import 'package:msg/src/core/msg.dart';
import 'package:msg/src/misc/typedefs.dart';

abstract class Cmd<Model> {
  const Cmd();

  const factory Cmd.none() = CmdNone;
  const factory Cmd.ofMsg(FutureOr<Msg<Model>> msg) = CmdMsg;
  const factory Cmd.ofEffect(Effect effect) = CmdEffect;
  const factory Cmd.batch(List<Cmd<Model>> cmds) = CmdBatch;
  const factory Cmd.stream(Stream<Cmd<Model>> cmds) = CmdStream;
}

