import 'dart:async';

import 'package:msg/src/core/cmd.dart';
import 'package:msg/src/core/msg.dart';
import 'package:msg/src/misc/typedefs.dart';

class CmdNone<Model> extends Cmd<Model> {
  const CmdNone();
}

class CmdMsg<Model> extends Cmd<Model> {
  final FutureOr<Msg<Model>> msg;

  const CmdMsg(this.msg);
}

class CmdEffect<Model> extends Cmd<Model> {
  final Effect effect;

  const CmdEffect(this.effect);
}

class CmdBatch<Model> extends Cmd<Model> {
  final List<Cmd<Model>> cmds;

  const CmdBatch(this.cmds);
}

class CmdStream<Model> extends Cmd<Model> {
  final Stream<Cmd<Model>> cmds;

  const CmdStream(this.cmds);
}
